//----------------------------------------------------------------------------
// wxDCClipper
//----------------------------------------------------------------------------
#ifndef __CLASS_WX_DCCLIPPER_H__
#define __CLASS_WX_DCCLIPPER_H__
#include <wx/dc.h>

Gura_BeginModuleScope(wx)

//----------------------------------------------------------------------------
// Class declaration for wxDCClipper
//----------------------------------------------------------------------------
Gura_DeclareUserClass(wx_DCClipper);

//----------------------------------------------------------------------------
// Object declaration for wxDCClipper
//----------------------------------------------------------------------------
class Object_wx_DCClipper : public Object {
protected:
	wxDCClipper *_pEntity;
	GuraObjectObserver *_pObserver;
	bool _ownerFlag;
public:
	Gura_DeclareObjectAccessor(wx_DCClipper)
public:
	inline Object_wx_DCClipper(wxDCClipper *pEntity, GuraObjectObserver *pObserver, bool ownerFlag) :
				Object(Gura_UserClass(wx_AboutDialogInfo)),
				_pEntity(pEntity), _pObserver(pObserver), _ownerFlag(ownerFlag) {}
	inline Object_wx_DCClipper(Class *pClass, wxDCClipper *pEntity, GuraObjectObserver *pObserver, bool ownerFlag) :
				Object(pClass),
				_pEntity(pEntity), _pObserver(pObserver), _ownerFlag(ownerFlag) {}
	virtual ~Object_wx_DCClipper();
	virtual Object *Clone() const;
	virtual String ToString(bool exprFlag);
	inline void SetEntity(wxDCClipper *pEntity, GuraObjectObserver *pObserver, bool ownerFlag) {
		if (_ownerFlag) delete _pEntity;
		_pEntity = pEntity;
		_pObserver = pObserver;
		_ownerFlag = ownerFlag;
	}
	inline void InvalidateEntity() { _pEntity = nullptr, _pObserver = nullptr, _ownerFlag = false; }
	inline wxDCClipper *GetEntity() {
		return static_cast<wxDCClipper *>(_pEntity);
	}
	inline wxDCClipper *ReleaseEntity() {
		wxDCClipper *pEntity = GetEntity();
		InvalidateEntity();
		return pEntity;
	}
	inline void NotifyGuraObjectDeleted() {
		if (_pObserver != nullptr) _pObserver->GuraObjectDeleted();
	}
	inline bool IsInvalid(Environment &env) const {
		if (_pEntity != nullptr) return false;
		SetError_InvalidWxObject(env, "wxDCClipper");
		return true;
	}
};

Gura_EndModuleScope(wx)

#endif
